#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <math.h>
#include <GL/glut.h>

#define MAXPTS 200
#define EPS 0.000001
#define STEP 0.01

int mousex, mousey;
int sirka=640, vyska=480;
int pts=0,color=1;
double P[205][2],beta1[205],beta2[205];
int sel_pt=-1,last_pt=2,is_ctrl=0,is_alt=0;

void PisBitmapovyText(int x, int y, char *string, void *font) {
  int len, i;
  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) glutBitmapCharacter(font, string[i]);
}

void draw_segment(double a0,double a1,double b0,double b1,double c0,double c1,double d0,double d1) {
  double t,pom[2];
  
  glColor3d(0.3, 0.3, 0.3);
  glBegin(GL_LINE_STRIP); glVertex2d(a0,a1); glVertex2d(b0,b1); glVertex2d(c0,c1); glVertex2d(d0,d1); glEnd();

  if (color) glColor3d(1.0,0.33,0.0); else glColor3d(1.0,1.0,0.0); color=1-color;
  glBegin(GL_LINE_STRIP);
    for (t=0.0;t<1.0+STEP-EPS;t+=STEP) {
      pom[0] =a0*pow(t,0)*pow(1-t,3);
      pom[1] =a1*pow(t,0)*pow(1-t,3);
      pom[0]+=b0*3*pow(t,1)*pow(1-t,2);
      pom[1]+=b1*3*pow(t,1)*pow(1-t,2);
      pom[0]+=c0*3*pow(t,2)*pow(1-t,1);
      pom[1]+=c1*3*pow(t,2)*pow(1-t,1);
      pom[0]+=d0*pow(t,3)*pow(1-t,0);
      pom[1]+=d1*pow(t,3)*pow(1-t,0);
      glVertex2dv(pom);
    }
  glEnd();
  
  glPointSize(6);
  glColor3d(0.6, 0.6, 0.6);
  glBegin(GL_POINTS); glVertex2d(a0,a1); glVertex2d(b0,b1); glVertex2d(c0,c1); glVertex2d(d0,d1); glEnd(); 
}

void display(void) {
  int i,j;
  double A[2],B[2],C[2],D[2],E[2],F[2],G[2],H[2];
  char pom[100];
  
  glClear(GL_COLOR_BUFFER_BIT); color=1;
//  glColor3d(0.3, 0.3, 0.3);
//  glBegin(GL_LINE_STRIP); for (i=0;i<pts;i++) glVertex3dv(P[i]); glEnd();

  if (pts>=4) { 
    
    draw_segment(P[0][0],P[0][1],P[1][0],P[1][1],P[2][0],P[2][1],P[3][0],P[3][1]);
    
    A[0]=P[0][0]; A[1]=P[0][1]; B[0]=P[1][0]; B[1]=P[1][1]; C[0]=P[2][0]; C[1]=P[2][1]; D[0]=P[3][0]; D[1]=P[3][1];
//    A[0]=P[0][0]; A[1]=P[0][1]; B[0]=P[0][0]; B[1]=P[0][1]; C[0]=P[0][0]; C[1]=P[0][1]; D[0]=P[0][0]; D[1]=P[0][1];
    for (i=3;i<pts-1;i++) {
      E[0]=D[0]; E[1]=D[1];
      F[0]=D[0]+beta1[i]*(D[0]-C[0]); F[1]=D[1]+beta1[i]*(D[1]-C[1]);
      G[0]=beta1[i]*beta1[i]*B[0] - (2*beta1[i]+2*beta1[i]*beta1[i]+(beta2[i]/2))*C[0] 
          + (1+2*beta1[i]+beta1[i]*beta1[i]+(beta2[i]/2))*D[0];
      G[1]=beta1[i]*beta1[i]*B[1] - (2*beta1[i]+2*beta1[i]*beta1[i]+(beta2[i]/2))*C[1] 
          + (1+2*beta1[i]+beta1[i]*beta1[i]+(beta2[i]/2))*D[1];
      H[0]=P[i+1][0]; H[1]=P[i+1][1];
      
      draw_segment(E[0],E[1],F[0],F[1],G[0],G[1],H[0],H[1]);
      
      A[0]=E[0]; A[1]=E[1]; B[0]=F[0]; B[1]=F[1]; C[0]=G[0]; C[1]=G[1]; D[0]=H[0]; D[1]=H[1];
    }
  }

  glPointSize(10);
  glColor3d(0.6, 0.0, 0.0);
  glBegin(GL_POINTS); for (i=0;i<pts;i++) glVertex2dv(P[i]); glEnd(); 
  glColor3d(0.0, 0.6, 0.0);
  if (last_pt!=-1) glBegin(GL_POINTS); glVertex2dv(P[last_pt]); glEnd(); 
  
  for (i=0;i<pts;i++) {
    sprintf(pom,"%.2f",beta1[i]);
    if ((is_ctrl) && (i==last_pt)) glColor3d(0.0,1.0,0.0); else glColor3d(0.5,0.5,0.5);
    PisBitmapovyText((int)(P[i][0]+5),(int)(P[i][1]+5),pom,GLUT_BITMAP_TIMES_ROMAN_10);
    
    sprintf(pom,"%.2f",beta2[i]);
    if ((is_alt) && (i==last_pt)) glColor3d(0.0,1.0,0.0); else glColor3d(0.5,0.5,0.5);
    PisBitmapovyText((int)(P[i][0]+5),(int)(P[i][1]+17),pom,GLUT_BITMAP_TIMES_ROMAN_10);
  }

  glutSwapBuffers();
}

void reshape(int w, int h) {
  sirka=w; vyska=h;
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, w, 0, h);
  glScalef(1, -1, 1);
  glTranslatef(0, -h, 0);
  glMatrixMode(GL_MODELVIEW);
}

void keypressed(unsigned char key, int x, int y) { 
  is_ctrl=glutGetModifiers(); is_alt=is_ctrl&GLUT_ACTIVE_ALT; is_ctrl=is_ctrl&GLUT_ACTIVE_CTRL;
  if (key == 27) exit(0); 
  glutPostRedisplay();
}

void keypressed_special(int key, int x, int y) { 
  is_ctrl=glutGetModifiers(); is_alt=is_ctrl&GLUT_ACTIVE_ALT; is_ctrl=is_ctrl&GLUT_ACTIVE_CTRL;
  if (last_pt==-1) return;
  
  switch (key) {
    case GLUT_KEY_UP: 
      if (is_ctrl) beta1[last_pt]+=0.01;
      if (is_alt)  beta2[last_pt]+=0.01;
    break;
    case GLUT_KEY_DOWN: 
      if (is_ctrl) beta1[last_pt]-=0.01;
      if (is_alt)  beta2[last_pt]-=0.01;
    break;
  }
  glutPostRedisplay();
}

void motion(int x, int y) {
  if (sel_pt!=-1) { P[sel_pt][0]=x; P[sel_pt][1]=y; }
  mousex = x; mousey = y;
  glutPostRedisplay();
}

void mouse(int b, int s, int x, int y) {
  int i,j,ok;
  
//  is_ctrl=glutGetModifiers(); is_alt=is_ctrl&GLUT_ACTIVE_ALT; is_ctrl=is_ctrl&GLUT_ACTIVE_CTRL;

  mousex = x; mousey = y;
  if (b==GLUT_LEFT_BUTTON){
    if (s==GLUT_DOWN) {
      ok=1;
      for (i=0;i<pts;i++) if ((abs(P[i][0]-x)<=4) && (abs(P[i][1]-y)<=4)) {
        ok=0;  
        for (j=i;j<pts-1;j++) { P[j][0]=P[j+1][0]; P[j][1]=P[j+1][1]; }
        pts--; last_pt=-1;
        break;
      }
      if ((ok) && (pts<MAXPTS)) { P[pts][0]=x; P[pts][1]=y; beta1[pts]=beta2[pts]=0.3; last_pt=pts; pts++; }
    }
  }
  
  if (b==GLUT_MIDDLE_BUTTON) {
    if (s==GLUT_DOWN) {
      sel_pt=-1;
      for (i=0;i<pts;i++) if ((abs(P[i][0]-x)<=4) && (abs(P[i][1]-y)<=4)) { sel_pt=i; last_pt=i; break; }
    } else { sel_pt=-1; }
  }
  
  glutPostRedisplay();
  motion(x,y);
}

/*
void menu(int choice) {
  switch(choice) {
    case 1: MODE=ANALYTIC; break;
    case 2: MODE=CASTELJAU; break;
  }
  glutPostRedisplay();
}
*/

int main(int argc, char **argv) {
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
  
  glutInitWindowSize(640, 480); glutInitWindowPosition(0, 0);
  glutCreateWindow("Miso Forisek -- DU #4");
  glClearColor(0.0, 0.0, 0.0, 0.0); glColor3d(1.0, 0.0, 0.0); glLineWidth(1.0);
  
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(keypressed);
  glutSpecialFunc(keypressed_special);
  glutMotionFunc(motion);
  glutMouseFunc(mouse);
  
//  glutCreateMenu(menu); glutAddMenuEntry("Analytic", 1); glutAddMenuEntry("Casteljau", 2);
//  glutAttachMenu(GLUT_RIGHT_BUTTON);

  glutMainLoop();
  return 0;
}
