#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <math.h>
#include <GL/glut.h>

#define MAXPTS 200
#define EPS 0.000001
#define STEP 0.01
#define CARDINAL 1
#define BETA 2

int mousex, mousey;
int sirka=640, vyska=480;
int pts=0,mode=CARDINAL;
double ALPHA=0.7,BETA1=0.3,BETA2=0.0;
double P[205][3];
int sel_pt=-1,color=0;
double M[4][4];
int is_ctrl,is_alt,is_shift;

void PisBitmapovyText(int x, int y, char *string, void *font) {
  int len, i;
  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) glutBitmapCharacter(font, string[i]);
}

void DrawSplineSegment(double x0, double y0, double x1, double y1, double x2, double y2, double x3, double y3) {
  int i,j;
  double P1[4],V1[4],P2[4],V2[4];
  double t,x,y,pom;
  
  V1[0]=x0; V1[1]=x1; V1[2]=x2; V1[3]=x3; 
  for (i=0;i<4;i++) { P1[i]=0; for (j=0;j<4;j++) P1[i]+=M[i][j]*V1[j]; }
  V2[0]=y0; V2[1]=y1; V2[2]=y2; V2[3]=y3; 
  for (i=0;i<4;i++) { P2[i]=0; for (j=0;j<4;j++) P2[i]+=M[i][j]*V2[j]; }

  if (color) glColor3d(1.0,1.0,0.0); else glColor3d(1.0,0.33,0.0); color=!color;
  
  glBegin(GL_LINE_STRIP);
  for (t=0.0;t<1.0+STEP-EPS;t+=STEP) {
    x=0; pom=1.0; for (i=3;i>=0;i--) { x+=pom*P1[i]; pom*=t; }
    y=0; pom=1.0; for (i=3;i>=0;i--) { y+=pom*P2[i]; pom*=t; }
    glVertex2d(x,y);
  }
  glEnd();
}

void display(void) {
  int i,j;
  char pom[100];
  
  glClear(GL_COLOR_BUFFER_BIT);
  glColor3d(0.3, 0.3, 0.3);
  glBegin(GL_LINE_STRIP); for (i=0;i<pts;i++) glVertex3dv(P[i]); glEnd();
  color=0;

  switch (mode) {
    case CARDINAL:
      M[0][0]=-ALPHA;  M[0][1]=2-ALPHA; M[0][2]=ALPHA-2;   M[0][3]=ALPHA; 
      M[1][0]=2*ALPHA; M[1][1]=ALPHA-3; M[1][2]=3-2*ALPHA; M[1][3]=-ALPHA; 
      M[2][0]=-ALPHA;  M[2][1]=0;       M[2][2]=ALPHA;     M[2][3]=0; 
      M[3][0]=0;       M[3][1]=1;       M[3][2]=0;         M[3][3]=0; 

      glColor3d(1.0,1.0,1.0);
      sprintf(pom,"Alpha = %.2f (Shift + Up/Down to modify)",ALPHA);
      PisBitmapovyText(10,10,pom,GLUT_BITMAP_TIMES_ROMAN_10);
    break;
    case BETA:
      M[0][0]=-2*pow(BETA1,3);                  M[0][1]=2*(pow(BETA1,3)+pow(BETA1,2)+BETA1+BETA2); 
      M[0][2]=-2*(pow(BETA1,2)+BETA1+BETA2+1);  M[0][3]=2;

      M[1][0]=6*pow(BETA1,3);                   M[1][1]=-3*(2*pow(BETA1,3)+2*pow(BETA1,2)+BETA2);
      M[1][2]=3*(2*pow(BETA1,2)+BETA2);         M[1][3]=0;

      M[2][0]=-6*pow(BETA1,3);                  M[2][1]=6*BETA1*(pow(BETA1,2)-1);
      M[2][2]=6*BETA1;                          M[2][3]=0;

      M[3][0]=2*pow(BETA1,3);                   M[3][1]=4*pow(BETA1,2)+4*BETA1+BETA2;
      M[3][2]=2;                                M[3][3]=0;
      for (i=0;i<4;i++) for (j=0;j<4;j++)
        M[i][j] /= ( 2*pow(BETA1,3) + 4*pow(BETA1,2) + 4*BETA1 + BETA2 + 2 );
      
      glColor3d(1.0,1.0,1.0);
      sprintf(pom,"Beta1 = %.2f (Ctrl + Up/Down to modify)",BETA1);
      PisBitmapovyText(10,10,pom,GLUT_BITMAP_TIMES_ROMAN_10);
      sprintf(pom,"Beta2 = %.2f (Alt + Up/Down to modify)",BETA2);
      PisBitmapovyText(10,22,pom,GLUT_BITMAP_TIMES_ROMAN_10);
    break;
  }

  if (pts>=4) {
    DrawSplineSegment(P[0][0],P[0][1],P[0][0],P[0][1],P[1][0],P[1][1],P[2][0],P[2][1]);
    for (i=0;i+3<pts;i++) 
      DrawSplineSegment(P[i][0],P[i][1],P[i+1][0],P[i+1][1],P[i+2][0],P[i+2][1],P[i+3][0],P[i+3][1]);
    DrawSplineSegment(P[pts-3][0],P[pts-3][1],P[pts-2][0],P[pts-2][1],P[pts-1][0],P[pts-1][1],P[pts-1][0],P[pts-1][1]);
  }
  
  glPointSize(10);
  glColor3d(0.6, 0.0, 0.0);
  glBegin(GL_POINTS); for (i=0;i<pts;i++) glVertex3dv(P[i]); glEnd(); 

  glutSwapBuffers();
}

void reshape(int w, int h) {
  sirka=w; vyska=h;
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, w, 0, h);
  glScalef(1, -1, 1);
  glTranslatef(0, -h, 0);
  glMatrixMode(GL_MODELVIEW);
}

void keypressed(unsigned char key, int x, int y) { 
  if (key == 27) exit(0); 
}

void keypressed_special(int key, int x, int y) {
  is_ctrl=glutGetModifiers(); 
  is_alt=is_ctrl&GLUT_ACTIVE_ALT; 
  is_shift=is_ctrl&GLUT_ACTIVE_SHIFT; 
  is_ctrl=is_ctrl&GLUT_ACTIVE_CTRL;
  
  switch (key) {
    case GLUT_KEY_UP:
      if (is_shift)ALPHA+=0.01;
      if (is_ctrl) BETA1+=0.01;
      if (is_alt)  BETA2+=0.1;
    break;
    case GLUT_KEY_DOWN:
      if (is_shift)ALPHA-=0.01;
      if (is_ctrl) BETA1-=0.01;
      if (is_alt)  BETA2-=0.1;
    break;
  }
  glutPostRedisplay();
}

void motion(int x, int y) {
  if (sel_pt!=-1) { P[sel_pt][0]=x; P[sel_pt][1]=y; }
  mousex = x; mousey = y;
  glutPostRedisplay();
}

void mouse(int b, int s, int x, int y) {
  int i,j,ok;

  mousex = x; mousey = y;
  if (b==GLUT_LEFT_BUTTON){
    if (s==GLUT_DOWN) {
      ok=1;
      for (i=0;i<pts;i++) if ((abs(P[i][0]-x)<=4) && (abs(P[i][1]-y)<=4)) {
        ok=0;  
        for (j=i;j<pts-1;j++) { P[j][0]=P[j+1][0]; P[j][1]=P[j+1][1]; }
        pts--; 
        break;
      }
      if ((ok) && (pts<MAXPTS)) { P[pts][0]=x; P[pts][1]=y; pts++; }
    }
  }
  
  if (b==GLUT_MIDDLE_BUTTON) {
    if (s==GLUT_DOWN) {
      sel_pt=-1;
      for (i=0;i<pts;i++) if ((abs(P[i][0]-x)<=4) && (abs(P[i][1]-y)<=4)) { sel_pt=i; break; }
    } else { sel_pt=-1; }
  }
  
  glutPostRedisplay();
  motion(x,y);
}

void menu(int choice) {
  switch(choice) {
    case 1: mode=CARDINAL; break;
    case 2: mode=BETA; break;
  }
  glutPostRedisplay();
}

int main(int argc, char **argv) {
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
  
  glutInitWindowSize(640, 480); glutInitWindowPosition(0, 0);
  glutCreateWindow("Miso Forisek -- DU #5");
  glClearColor(0.0, 0.0, 0.0, 0.0); glColor3d(1.0, 0.0, 0.0); glLineWidth(1.0);
  
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(keypressed);
  glutSpecialFunc(keypressed_special);
  glutMotionFunc(motion);
  glutMouseFunc(mouse);
  
  glutCreateMenu(menu); glutAddMenuEntry("Cardinal spline", 1); glutAddMenuEntry("Beta-spline", 2);
  glutAttachMenu(GLUT_RIGHT_BUTTON);

  glutMainLoop();
  return 0;
}
